#!/usr/bin/python

# Librarys import
import os
import socket
import time, datetime

# Server configuration
USER = "Guest"
HOST = "0.0.0.0"
PORT = 42020
CLTS = 1

# Client configuration
active = False			# Controls when we have an active chat window
socks = []				# List of sockets
clients = []			# List of clients
interval = 1			# Interval to sleep (1sec = default)

# Clear function (keepin' things clean ;)
clf = 'clear'
if os.name == 'posix': clf = 'clear'
if os.name == 'nt': clf = 'cls'
clear = lambda: os.system(clf)

# Get time function
ts = time.time()
st = datetime.datetime.fromtimestamp(ts).strftime('%H:%M')
def GetTime():
	ts = time.time()
	st = datetime.datetime.fromtimestamp(ts).strftime('%H:%M')
	return st

# Send data function
def Send(sock, data, end="EOFX"):
	sock.sendall(data + end)

# Receive data function
def Receive(sock, end="EOFX"):
	data = ""
	l = sock.recv(1024)
	while(l):
		data = l
		if data.endswith(end) == True:
			break
		else:
			l = sock.recv(1024)
	return data[:-len(end)]

# Username prompt and print it
clear()
try:
	usr = raw_input("\n[*] Enter username: ")
	if len(usr) < 1:
		USER = "Guest"
	else:
		USER = usr
except:
	USER = "Guest"

# Let's greet the user!
print "\n[" + GetTime() + "] Welcome " + USER + "!"

# Initialize the server socket
c = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
c.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
c.bind((HOST, PORT))
c.listen(CLTS)			# Listen for total of X clients

print "\n[" + GetTime() + "] Listening on " + HOST + " (" + str(PORT) + ") for a total of " + str(CLTS) + " clients."

# Client testing begins here ------------------------->

time.sleep(interval*2)

CLIENT = raw_input("\n[" + GetTime() + "] What address are you connecting to? ")
PORT = raw_input("\n[" + GetTime() + "] What port are you connecting to? ")

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.connect((CLIENT, int(PORT)))

time.sleep(interval*2)

Send(s, "Hello, this is the first message!")

time.sleep(interval*2)

Send(s, "Time for message number two! Ayyy ;)")

time.sleep(interval*2)

s,a = c.accept()
if (s):
	print "\n[" + GetTime() + "] Connection from " + str(a)

	try:
		while True:
			msg = Receive(s)
			if len(str(msg)): print "\n[" + GetTime() + "] " + msg

			time.sleep(interval)

			if msg[:4] == 'port':
				print "\n[" + GetTime() + " Connecting to: " + str(a[0]) + " on " + msg
				ps = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
				ps.connect((str(a[0]), int(msg[-5:])))

				time.sleep(interval)

				# Finally open the private chat communication
				while True:
					ms = raw_input("\n[" + GetTime() + "] Enter message: ")
					if ms == 'quit': break
					else: Send(ps, ms)

	except KeyboardInterrupt:
		print ">>> Finished."